
/**
 * Ok, fine, "mob" is a bit of an overstatement.  This class helps manage
 * a pair of deadly turtles.
 *
 * @author Brad Richards
 * @version 1.0
 */
public class TurtleMob
{
    Turtle comet;   // Our first, ferocious turtle
    Turtle cupid;   // Don't let the name fool you...

    /**
     * This copy constructor sets up our "mob" to look exactly like the
     * TurtleMob instance passed in as an input.  We need to make sure
     * that the two turtles we manage are completely separate from the two
     * turtles in the other "mob", and that the Circles in our two turtles
     * are separate from their Circles but have the same state.
     * 
     * @param otherMob  A reference to another TurtleMob object we want to copy
     */
    public TurtleMob(TurtleMob otherMob) 
    {
        // Your code goes here...
    }
    
    /**
     * Default constructor for objects of class TurtleMob.  It makes a 
     * pair of Turtle instances with the same "speed", then calls splitUp()
     * to make sure they're not at exactly the same position on the screen.
     */
    public TurtleMob()
    {
        comet = new Turtle(40);     // Make a new Turtle
        cupid = new Turtle(40);     // Make an identical second Turtle
        splitUp();                  // Move them apart
    }
    
    /**
     * Causes the two Turtles to move apart horizontally, then leaves them
     * both facing south.
     */
    public void splitUp()
    {
        comet.faceWest();
        cupid.faceEast();
        comet.forward();
        cupid.forward();
        comet.faceSouth();
        cupid.faceSouth();
    }
    
    /**
     * Moves both turtles forward one "step".
     */
    public void advance()
    {
        comet.forward();
        cupid.forward();
    }
    
    /**
     * Compares "us" to another TurtleMob.  It returns true if *all* details
     * of our first turtle match theirs (including the Circle within it), and
     * the same is true for our second turtle and theirs.
     * 
     * @param other  A reference to the TurtleMob to which we will compare ourselces
     * @return  True if our turtles match their turtles, false otherwise.
     */
    public boolean equals(TurtleMob other) 
    {
        // Need to check if "our" comet is the same as theirs, and our cupid
        // also matches theirs.  How can you tell if two Turtles are the same?
        
        return false;   // To keep compiler happy for now
    }
    
    /**
     * Compares our two turtles to see if they're at the same position on the
     * screen.  There's no method in the Turtle class that can help us here, 
     * so we need to go look into their Circle objects, get their X and Y
     * positions, and compare those.
     * 
     * @return True if our circles are at the same spot on the screen.
     */
    public boolean sameSpot()
    {
        return false;       // To keep compiler happy for now...
    }
}
